// Red, green, and blue pins for PWM control
const int bluePin = 25;    // 14 corresponds to GPIO14
const int redPin = 26;     // 13 corresponds to GPIO13
const int greenPin = 27;   // 12 corresponds to GPIO12
int redAmp = 0;
int greenAmp = 0;
int blueAmp = 0;
float redDec=0;
float greenDec=0;
float blueDec=0;


// Setting PWM frequency, channels and bit resolution
const int freq = 5000;
const int redChannel = 0;
const int greenChannel = 1;
const int blueChannel = 2;
// Bit resolution 2^8 = 256
const int resolution = 8;


// Previous time
unsigned long currentTime = 0;
unsigned long previousTime = 0;
unsigned long tempTime = 0;
const long timeoutTemp = 40;
// Define timeout time in milliseconds (example: 2000ms = 2s)
const long timeoutTime = 5000;

void ledInit() {
  ledcSetup(redChannel, freq, resolution);
  ledcSetup(greenChannel, freq, resolution);
  ledcSetup(blueChannel, freq, resolution);

  // attach the channel to the GPIO to be controlled
  ledcAttachPin(redPin, redChannel);
  ledcAttachPin(greenPin, greenChannel);
  ledcAttachPin(bluePin, blueChannel);
  ledcWrite(redChannel, 254);
  ledcWrite(greenChannel, 254);
  ledcWrite(blueChannel, 254);
  currentTime = millis();
  previousTime = currentTime;
  tempTime = currentTime;
}

void changeLed() {
  currentTime = millis();
  if ( (currentTime - previousTime) > timeoutTime ) {
    
    redAmp = int(random(255));
    greenAmp = int(random(255));
    blueAmp = int(random(255));
    redDec=int(redAmp/(timeoutTime)/float(timeoutTemp))+1;
    greenDec=int(greenAmp/(timeoutTime/timeoutTemp))+1;
    blueDec=int(blueAmp/(timeoutTime/timeoutTemp))+1;
    
    ledcWrite(redChannel, redAmp);
    ledcWrite(greenChannel, greenAmp);
    ledcWrite(blueChannel, blueAmp);
    previousTime = currentTime;
    DebugSerial.print("Reset led\n");
  }
  /*
  else if ( (currentTime - tempTime) > timeoutTemp) {
    redAmp = redAmp - redDec; if (redAmp < 0) redAmp = 0;
    greenAmp = greenAmp - greenDec; if (greenAmp < 0) greenAmp = 0;
    blueAmp = blueAmp - blueDec; if (blueAmp < 0) blueAmp = 0;
    ledcWrite(redChannel, redAmp);
    ledcWrite(greenChannel, greenAmp);
    ledcWrite(blueChannel, blueAmp);
    tempTime = currentTime;

    
  }
  */


}
