

/////// WIFI SECTION
#ifdef ESP8266
#include <ESP8266WiFi.h>       // Built-in
#include <ESP8266WiFiMulti.h>  // Built-in
#include <ESP8266WebServer.h>  // Built-in
#include <ESP8266mDNS.h>
#else
#include <WiFi.h>              // Built-in
// #include <WiFiMulti.h>         // Built-in
#include <ESP32WebServer.h>    // https://github.com/Pedroalbuquerque/ESP32WebServer download and place in your Libraries folder
#include <ESPmDNS.h>
#include "FS.h"
#endif

#include "Sys_Variables.h"
#include "CSS.h"
#include <SD.h>
#include <SPI.h>
ESP32WebServer server(80);
//////////////////////

/////// FEEDER SECTION
File currentFile;
File root;
// Storage for file information
const int MAX_FILES = 255;
int patternOrder[MAX_FILES];
int currentPattern = 0;
int fileCount = 0;
String filenames[MAX_FILES];
String homeFilename = "";
//settings for continuous pattern switches
//const int CONTINUE_PIN = 2;     // pin for continous switch
boolean abortPattern = false;   // Used to abort an in progress pattern
//const unsigned long DEBOUNCE_TIME_MS = 250;
// Aliases for serial ports
#define DebugSerial Serial
#define GrblSerial  Serial2
//////////////////////////
int workMode = 1;
boolean startFile = false;
boolean endFile = false;
boolean nextRow = false;

////////////////////////
const byte GRBL_Reset = 15;
const byte PinOut1 = 32;
const byte PinOut2 = 33;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void setup(void) {
  //////// SET PIN
  pinMode(GRBL_Reset, OUTPUT);
  digitalWrite(GRBL_Reset, LOW);    // Send Reset to low

  pinMode(PinOut1, OUTPUT);
  digitalWrite(PinOut1, LOW);    // Send Reset to low

  pinMode(PinOut2, OUTPUT);
  digitalWrite(PinOut2, LOW);    // Send Reset to low

  ledInit();

  ////// GCODE FEEDER SECTION
  setup_gcode();

  /////// WIFI SECTION
  wifi_setup();

  ////// start drawing
  workMode = 2;
  homeTable();


}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void loop(void) {
  changeLed();
  server.handleClient(); // Listen for client connections

  /*
      String DbgLine = "";
        while (DebugSerial.available()) {
          // get the new byte:
          char inChar = (char)DebugSerial.read();
          // add it to the inputString:
          DbgLine += inChar;
          // if the incoming character is a newline, set a flag so the main loop can
          // do something about it:

          delay(1);
        }
        if (DbgLine.length()>0){
          GrblSerial.print(DbgLine); // print grbl return on serial
          DebugSerial.print(DbgLine);
        }
  */
  

  if (workMode == 2) /// DRAWING MODE
  {
    readGrbl();
    if (!startFile) { //grbl sending not started
      abortPattern = false;
      openFileSD(); // Opens the currentPattern
      startGcode();
    }



    if (startFile && !endFile && nextRow) {
      sendGcode();  // sends the file to the controller
    }

    if (endFile) {
      nextPattern();
    }
  }

}
